#include <stdio.h>
#include <string.h>
#include "FormValues.h"
#include "log.h"

FormValues::FormValues( char* text ) {
	gotEndOfHeader = false;
	idx = 0;
	char* endOfHeader = strstr( text, "\r\n\r\n" );
	if ( endOfHeader != NULL ) {
		log_message1( "Got values: ", endOfHeader+4 );
		char* token = strtok( endOfHeader + 4, "&" );
		while ( token != NULL ) {
			log_message1("Token is:", token );
			addValue( token );
			token = strtok( NULL, "&" );
		}
		gotEndOfHeader = true;
	} else {
		log_message( "did not get end of header" );
	}

}

void FormValues::addValue( char* nv ) {
	char* name = nv;
	while ( *nv && ( *nv != '=' )) {
		nv++;
	}
	if ( *nv == '=' ) {
		*nv = 0;
		char* value = nv + 1;
		addValue( name, value );
	}
}

void FormValues::addValue( char* name, char* value ) {
	names[ idx ] = name;
	values[ idx++ ] = value;
}

void FormValues::Dump() {
	for ( int i = 0; i < idx; i++ ) {
		log_message1( names[i], values[i] );
	}
}

char* FormValues::grabValue( char* name ) {
	for ( int i = 0; i < idx; i++ ) {
		if ( strcmp( name, names[i] ) == 0 ) {
			return( values[i] );
		}
	}
	return( NULL );
}